//---------------------------------------------------------------------------


#pragma hdrstop

#include "lang.h"
#include "winutil.h"
#include <string>
#include <vector>

//---------------------------------------------------------------------------

#pragma package(smart_init)

//---------------------------------------------------------------------------
// Language Functions:
//---------------------------------------------------------------------------

AnsiString English[] = {"English","Inactive", "Active", "Exit", "About","Options", "OK",
                        "Hotkey", "Cancel", "Start mode", "Last setting",
                        "Remove my settings from registry",
                        "Do you wish to remove all your settings from the registry?",
                        "Hotkey function","Copy only on hotkey",
                        "Toggle active/inactive",
                        "Remove leading and trailing whitespaces",
                        "Remove leading and trailing linebreaks",
                        "Always start with Windows",
                        "Copy only links",
                        "For online-help check the following website",
                        "Language", "Auto",
                        "Linktype", "All", "Pictures", "Movies","Email","Web","Music","FTP","Archives",
                        "General", "Linktypes","Add","Delete","Name","Wildcard",
                        "Predefined field cannot be deleted"
                        };


AnsiString Danish[] = {"Dansk","Inaktiv", "Aktiv", "Afslut", "Om HovText", "Indstillinger","OK",
                        "Genvejstast", "Annuller", "Start tilstand", "Sidste tilstand",
                        "Fjern mine indstillinger fra registreringsdatabasen",
                        "Vil du fjerne alle dine indstillinger fra registeringsdatabasen?",
                        "Genvejstast funktion"," Kopier kun ved genvejstast",
                        "Skift mellem aktiv/inaktiv",
                        "Fjern mellemrum i start og slutning af teksten",
                        "Fjern linjeskift i start og slutning af teksten",
                        "Start automatisk sammen med Windows",
                        "Kopir kun links",
                        "For online-hjlp se nedenstende hjemmeside",
                        "Sprog", "Auto",
                        "Linktype", "Alle", "Billeder", "Film","Email","Web","Musik","FTP","Arkiver",
                        "Generelt", "Linktyper","Tilfj","Slet","Navn","Sgestreng",
                        "Prdefinerede felter kan ikke slettes"
                        };


AnsiString German[] = {"Deutsch", "Inaktiv","Aktiv", "Exit","ber","Wahl","OK",
                       "Schnelltaste","Abbrechen", "Startmodus","Vorige Einstellung",
                       "Meine Einstellungen von Datenbank lschen",
                       "Alle meine Einstellungen von Datenbank lschen? ",
                       "Schnelltasten-Funktion","Nur ber Schnelltaste kopieren",
                       "Schalten zwischen aktiv/inaktiv",
                       "Leerfelder vor und nach Text entfernen ",
                       "Zeilenumbruch vor und nach Text entfernen",
                       "Automatisch zusammen mit Windows starten",
                       "Nur Links kopieren",
                       "Fr Online-Hilfe sehen Sie bitte diese Website",
                       "Sprache", "Auto",
                       "Linktypen","Alle","Photos","Film","Email","Web","Musik","FTP","Archivieren",
                       "Generell","Linktypen","Zufgen","Lschen","Titel","Suchestring",
                       "Dieses Feld lschen?",
                       "Vordefinierte Felder knnen nicht gelscht werden"
                       };



AnsiString Dutch[] = { "Nederlands", "Niet actief","Actief","Afsluiten","Over", "Opties","OK",
                       "Hotkey","Afbreken","Opstartmode","Laatste instelling",
                       "Verwijder mijn instellingen uit register",
                       "Wilt u al uw instellingen verwijderen uit het register?",
                       "Hotkey functie","Kopieer alleen naar hotkey",
                       "Toggle actief/niet actief",
                       "Verwijder de spaties voor en na de tekst",
                       "Verwijder de witregels voor en na de tekst",
                       "Altijd starten met Windows",
                       "Copieer alleen links",
                       "Voor on-line help ga naar de volgende site",
                       "Kies een taal", "Auto",
                        "Linktype", "All", "Pictures", "Movies","Email","Web","Music","FTP","Archives",
                        "General", "Linktypes","Add","Delete","Name","Wildcard",
                        "Predefined field cannot be deleted"
                       };


AnsiString French[] = { "Franais", "Dsactiv", "Activ", "Quitter", "A propos","Options", "OK", "Raccourci clavier", "Annuler",
                        "Mode au dmarrage", "Dernier paramtre", "Retirer mes paramtres du registre",
                        "Souhaitez-vous retirer tous vos paramtres du registre ?",
                        "Fonction du raccourci","Copier uniquement sur utilisation","Activer/Dsactiver",
                        "Retirer les blancs en tte et en queue",
                        "Retirer les sauts de lignes en tte et en queue",
                        "Toujours lancer au dmarrage de Windows",
                        "Copier uniquement les liens",
                        "Pour l'aide en ligne, allez  l'adresse suivante",
                        "Langage", "Auto",
                        "Type de lien", "Tous", "Images", "Films","E-mail","Web","Musique","FTP","Archives",
                        "Gnral", "Types de lien","Ajouter","Effacer","Nom","Extensions",
                        "Le champ prdfini ne peut pas tre effac"
                        };

AnsiString Italian[] = { "Italiano", "Inattivo", "Attivo", "Esci", "Informazioni", "Opzioni", "OK", "Hotkey", "Annulla",
                         "Modalit d'avvio", "Ultime impostazioni", "Elimina le mie impostazioni dal registro",
                         "Desideri eliminare tutte le tue impostazioni dal registro?",
                         "Funzione della hotkey", "Copia solo con l'hotkey", "Attiva/Disattiva",
                         "Elimina spazi iniziali e finali",
                         "Elimina a capo iniziali e finali",
                         "Esegui sempre all'avvio di Windows",
                         "Copia solo i link",
                         "Per l'aiuto online vai al seguente indirizzo" ,
                         "Lingua", "Auto",
                         "Tipo di link", "Tutti", "Immagini", "Film", "Email", "Web", "Musica", "FTP", "Archivi",
                         "Generali", "Tipi di link","Aggiungi", "Cancella", "Nome", "Estensioni",
                         "I campi predefiniti non possono essere cancellati"
                       };
AnsiString Swedish[] = {"Svenska","Inaktiv", "Aktiv", "Avsluta", "Om","Instllningar", "OK",
                        "Kortkommando", "Avbryt", "Startlge", "Senaste instllning",
                        "Ta bort instllningar frn registret",
                        "Vill du ta bort alla instllningar frn registret?",
                        "Kortkommandofunktion","Kopiera endast vid kortkommando",
                        "Skifta aktiv/inaktiv",
                        "Ta bort tomrum i brjan och i slutet",
                        "Ta bort radbrytningar i brjan och i slutet",
                        "Starta alltid med Windows",
                        "Kopiera endast lnkar",
                        "G till fljande lnk fr onlinehjlp",
                        "Sprk", "Auto",
                        "Lnktyp", "Alla", "Bilder", "Filmer","E-post","Web","Musik","FTP","Arkiv",
                        "Allmnt", "Lnktyper","Lgg till","Radera","Namn","Jokertecken",
                        "Frdefinierade flt kan inte raderas"
                        };

WORD Name2LangId(AnsiString name)
{
  if (name==Danish[TE_LangName])       return LANG_DANISH;
  else if (name==German[TE_LangName])  return LANG_GERMAN;
  else if (name==Dutch[TE_LangName])   return LANG_DUTCH;
  else if (name==French[TE_LangName])  return LANG_FRENCH;
  else if (name==Italian[TE_LangName]) return LANG_ITALIAN;
  else if (name==Swedish[TE_LangName]) return LANG_SWEDISH;
  else if (name==English[TE_LangName]) return LANG_ENGLISH;
  else
    return 0;
}

short LangId2idx(WORD langid)
{
	switch(langid)
	{
	  case LANG_DANISH:  return 1;
	  case LANG_GERMAN:  return 2;
	  case LANG_ENGLISH: return 3;
	  case LANG_FRENCH:  return 4;
	  case LANG_ITALIAN: return 5;
	  case LANG_DUTCH:   return 6;
	  case LANG_SWEDISH: return 7;
	  default:           return 0;
	}
}


AnsiString LangText(TextEnum t)
{
  WORD langid=LangId2idx(GetRegInt("Language"));
  if (langid<=0)
    langid=LangId2idx((char)GetUserDefaultLCID());

	switch(langid)
	{
	  case 1:  return Danish[t];
	  case 2:  return German[t];
	  case 4:  return French[t];
	  case 5:  return Italian[t];
	  case 6:  return Dutch[t];
    case 7:  return Swedish[t];
	  default: return English[t];
	}
}

const std::vector<AnsiString>& LangList()
{
  static std::vector<AnsiString> langlist;

  langlist.clear();
  langlist.push_back(Danish[TE_LangName]);
  langlist.push_back(German[TE_LangName]);
  langlist.push_back(English[TE_LangName]);
  langlist.push_back(French[TE_LangName]);
  langlist.push_back(Italian[TE_LangName]);
  langlist.push_back(Dutch[TE_LangName]);
  langlist.push_back(Swedish[TE_LangName]);
  return langlist;

}

TLangNotifier LangNotifier;


void TLangNotifier::AddLangNotify(TLangChangeNotify *n)
{
  Clients.push_back(n);
}

void TLangNotifier::RemoveLangNotify(TLangChangeNotify *n)
{
}

void TLangNotifier::LangChange()                 
{
  for (std::vector <TLangChangeNotify *> ::iterator i =Clients.begin();
       i !=Clients.end(); i++)
     (*i)->LangChange();
}

